/*
 * NetcraftToolbar - Debugging Module
 *
 * Copyright (C) 2014 Netcraft Ltd
 * http://toolbar.netcraft.com/ 
 *
 * $Id: chrome:content:debug.js,v 1.8 2009/11/04 15:49:50 nrj Exp $
 */

if (!com) var com={};
if (!com.netcraft) com.netcraft={};
if (!com.netcraft.toolbar) com.netcraft.toolbar={};
 
com.netcraft.toolbar.debug = {
    constants: com.netcraft.toolbar.constants,
    consoleService: Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService),
    
    verbose: function (str) {
        if (!this.constants.NETCRAFT_VERBOSE)
            return;
    
        var parent = arguments.callee.caller.name || "<anonymous>";
        this.dumpstr(parent + ': "' + this.unctrl(str) + '"\n');
    },
    
    debug: function (str,obj) {
        if (!this.constants.NETCRAFT_DEBUG)
            return;
    
        var parent = arguments.callee.caller.name || "<anonymous>";
        this.pp(str, obj, parent + "| ");
    },
    
    pp: function (l,o,x) {
        if (!x) x = "";
        this.dumpstr( x + l + ": ");
        var isa, i;
        try {
        isa = typeof o;
        switch (isa) {
          case 'undefined':
            this.dumpstr("NULL\n");
            break;
          case 'number':
            this.dumpstr(o.toString() + "\n");
            break;
          case 'string':
            this.dumpstr('"' + this.unctrl(o) + '"\n');
            break;
          case 'boolean':
            this.dumpstr(o.toString().toUthis.pperCase() + "\n");
            break;
          case 'function':
            this.dumpstr(this.unctrl(o.toString().replace(/[\r\n]+/g," ").replace(/\s+/g," ")) + "\n");
            break;
          case 'object':
            if (o.constructor == Array) {
            this.dumpstr("[\n");
            for (i = 0; i < o.length; i++) {
                try {
                if (typeof o[i] == "object")
                    this.dumpstr(x + this.constants.TS + i + ": " + o[i] + "\n");
                else
                    this.pp(i, o[i], x + this.constants.TS);
                }
                catch (e) {
                this.dumpstr(x + this.constants.TS + i + ": *ERROR*\n");
                }
            }
            this.dumpstr(x + "]\n");
            }
            else {
            this.dumpstr("{\n");
            for(i in o) {
                try {
                if (typeof o[i] == "object")
                    this.dumpstr(x + this.constants.TS + i + ": " + o[i] + "\n");
                else
                    this.pp(i,o[i],x + this.constants.TS);
                }
                catch (e) {
                this.dumpstr(x + this.constants.TS + i + ": *ERROR*\n");
                }
            }
            this.dumpstr(x + "}\n");
            }
            break;
          default:
            this.dumpstr('<' + isa + ":" + o.toString() + '>');
            break;
        }
        }
        catch (e) {
        this.dumpstr("*ERROR: " + e + "*\n");
        return;
        }
    },
    
    dumpstr: function (s) {
        if (this.constants.NETCRAFT_CONSOLE)
        this.consoleService.logStringMessage(s);
        else
        dump(s);
    },

    consoleerror: function(error) {
        if (com.netcraft.toolbar.options.isShowDebugInConsole()) {
            Components.utils.reportError(this.constants.PT_CONSOLEERRORPREFIX + error);
        }
    },
    
    unctrl: function (s) {
        s = s.replace(/\\/g,'\\\\')
             .replace(/\f/g,'\\f')
         .replace(/\n/g,'\\n')
         .replace(/\r/g,'\\r')
         .replace(/\t/g,'\\t')
         .replace(/\v/g,'\\v');
    
        if (s.match(/[\000-\036\177-\377]/)) {
        var ns = "";
        for (var i = 0; i < s.length; i++) {
            var c = s.charCodeAt(i);
            ns += (c <= 30 || c >= 127)
            ? "\\" + c.toString(8)
            : String.fromCharCode(c);
        }
        s = ns;
        }
        return (s);
    }  
};
