/*
 * NetcraftToolbar - DNS Helper Module
 *
 * Copyright (C) 2014 Netcraft Ltd
 * http://toolbar.netcraft.com/ 
 *
 * $Id: chrome:content:dns.js,v 1.9 2009/11/18 13:10:44 nrj Exp $
 */

if (!com) var com={};
if (!com.netcraft) com.netcraft={};
if (!com.netcraft.toolbar) com.netcraft.toolbar={};
 
com.netcraft.toolbar.dns = {
    _dns: Components.classes["@mozilla.org/network/dns-service;1"].getService(Components.interfaces.nsIDNSService),

    dnsResolve: function (host, returnIP) {
        var threadManager = Components.classes["@mozilla.org/thread-manager;1"].getService(Components.interfaces.nsIThreadManager);
        var isCancelled = false;
        var isComplete = false;
        var DNSrequest = null;
        var listener = {
            onLookupComplete: function (aRequest, DNSrecord, aStatus) {
                isComplete = true;
                if(!isCancelled) {
                    try {
                        returnIP(DNSrecord.getNextAddrAsString());
                    } catch (e) {
                        returnIP("");
                    }
                }
            }
        };
        var canceller = function() {
            if(!isCancelled && !isComplete) {
                DNSrequest.cancel(Components.results.NS_ERROR_ABORT);
                isCancelled = true;
            }
        };
        DNSrequest = this._dns.asyncResolve(host, 0,listener,threadManager.currentThread);
        return canceller;
    },

    convertIP: function (ip) {
        var octets = ip.split('.');
        var num  = (octets[3] & 0xff);
            num += (octets[2] & 0xff) * (1<< 8);
            num += (octets[1] & 0xff) * (1<<16);
            num += (octets[0] & 0xff) * (1<<24);

        return num;
    },

    unroutableIP: function (ip) {
        var top2 = ip.split('.');
        var num = (
            (top2[0]&0xff) * (1<<16) + (top2[1]&0xff) * (1<<8) + (top2[2]&0xff)
        );
        return (
            ((num & 16711680) == 0) ||
            ((num & 16711680) == 655360) ||
            ((num & 16711680) == 8323072) ||
            ((num & 16776960) == 11140608) ||
            ((num & 16773120) == 11276288) ||
            ((num & 16776960) == 12625920) ||
            ((num & 16777215) == 12582914) ||
            ((num & 14680064) == 14680064)
        );
    }
};
