/*
 * NetcraftToolbar - Options Window
 *
 * Copyright (C) 2014 Netcraft Ltd
 * http://toolbar.netcraft.com/
 *
 * $Id: chrome:content:options.js,v 1.33 2009/11/18 13:10:44 nrj Exp $
 */

if (!com) var com={};
if (!com.netcraft) com.netcraft={};
if (!com.netcraft.toolbar) com.netcraft.toolbar={};

/*
 * Access to the preference service
 */
com.netcraft.toolbar.moz_preferences = {
    
    service: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),

    branch: function (node) {
        var node_branch = this.service.getBranch(node);

        return {    
            setIntPref: function (pref, i) {
                try {
                    node_branch.setIntPref(pref, i);
                } catch (e) {
                }
            },
        
            getIntPref: function (pref,dflt) {
                var i;
                try {
                    i = node_branch.getIntPref(pref);
                } catch (e) {
                    node_branch.setIntPref(pref, dflt);
                    i = node_branch.getIntPref(pref);
                }
                return i;
            },
        
            setCharPref: function (pref, s) {
                try {
                    node_branch.setCharPref(pref, s);
                } catch (e) {
                }
            },
        
            getCharPref: function (pref,dflt) {
                var s;
                try {
                    s = node_branch.getCharPref(pref);
                } catch (e) {
                    node_branch.setCharPref(pref, dflt);
                    s = node_branch.getCharPref(pref);
                }
                return s;
            },
        
            setBoolPref: function (pref, b) {
                try {
                    node_branch.setBoolPref(pref, b);
                } catch (e) {
                }
            },
        
            getBoolPref: function (pref,dflt) {
                var b;
                try {
                    b = node_branch.getBoolPref(pref);
                } catch (e) {
                    node_branch.setBoolPref(pref, dflt);
                    b = node_branch.getBoolPref(pref);
                }
                return b;
            }
        };
    }  
};

/*
 * Netcraft Toolbar Preferences
 */
com.netcraft.toolbar.options = {
    constants: com.netcraft.toolbar.constants,
     
    _root: com.netcraft.toolbar.moz_preferences.branch(null),
    _tree: com.netcraft.toolbar.moz_preferences.branch(com.netcraft.toolbar.constants.PT_BRANCHNAME),
    
    getUpdateInterval: function () {
        return this._root.setIntPref(this.constants.PT_EXTLASTUPDATE, 0);
    },
    
    setUpdateInterval: function () {
        this._root.setIntPref(this.constants.PT_EXTLASTUPDATE, 0);
    },

    isOffline: function () {
        return this._root.getBoolPref(this.constants.PT_BROWSEROFFLINE);
    },

    _genid: function () {
        var datepart = new Date().getTime().toString(16).toUpperCase();
        var randpart =
            ("000000000" + (Math.floor(Math.random() * 1e17)).toString(16)).
            substr(-9).toUpperCase();
        return(randpart + this.constants.PT_BUILDHEX + datepart);
    },

    newWindow: function () {
        return this._root.getIntPref(this.constants.PT_BROWSEROPEN);
    },

    bg: function () {
        return this._root.getBoolPref(this.constants.PT_BROWSERBG);
    },

    getVersion: function () {
        return this._tree.getCharPref(this.constants.PT_VERSIONPREF);
    },
    
    setVersion: function (vers) {
        this._tree.setCharPref(this.constants.PT_VERSIONPREF, vers);
    },
    
    popWindow: function () {
        window.openDialog(this.constants.PT_ABOUTWINDOWURI, this.constants.PT_ABOUTWINDOWTITLE, this.constants.PT_ABOUTWINDOWPARAMS);
    },

    isShowDebugInConsole: function () {
        return this._tree.getBoolPref(this.constants.PT_SHOWDEBUGINCONSOLE, false);
    }
};

com.netcraft.toolbar.options.uuid = com.netcraft.toolbar.options._tree.getCharPref(
    com.netcraft.toolbar.options.constants.PT_IDPREF,
    com.netcraft.toolbar.options._genid()
);

com.netcraft.toolbar.options.setVersion(com.netcraft.toolbar.options.constants.PT_VERSION);
